Index: /XIOS/dev/branch_yushan_merged/src/test/test_complete_omp.f90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/test/test_complete_omp.f90	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/src/test/test_complete_omp.f90	(revision 1134)
@@ -0,0 +1,345 @@
+PROGRAM test_complete_omp
+
+  USE xios
+  USE mod_wait
+  use omp_lib
+  IMPLICIT NONE
+  INCLUDE "mpif.h"
+  INTEGER :: rank, size
+  INTEGER :: size_loc
+  INTEGER :: ierr
+
+  CHARACTER(len=*),PARAMETER :: id="client"
+  INTEGER :: comm, comm2
+  TYPE(xios_duration)  :: dtime
+  TYPE(xios_context) :: ctx_hdl
+  INTEGER,PARAMETER :: ni_glo=100
+  INTEGER,PARAMETER :: nj_glo=100
+  INTEGER,PARAMETER :: llm=5
+  DOUBLE PRECISION  :: lval(llm)=1
+  TYPE(xios_field) :: field_hdl
+  TYPE(xios_fieldgroup) :: fieldgroup_hdl
+  TYPE(xios_file) :: file_hdl
+  LOGICAL :: ok
+  CHARACTER(len=256) :: crname
+
+  DOUBLE PRECISION,DIMENSION(ni_glo,nj_glo) :: lon_glo,lat_glo
+  DOUBLE PRECISION :: field_A_glo(ni_glo,nj_glo,llm)
+  DOUBLE PRECISION,ALLOCATABLE :: lon(:,:),lat(:,:),field_A_atm(:,:,:), field_A_srf(:,:), lonvalue(:,:)
+  INTEGER, ALLOCATABLE :: kindex(:)
+  INTEGER :: ni,ibegin,iend,nj,jbegin,jend
+  INTEGER :: i,j,l,ts,n, nb_pt, provided
+
+!!! MPI Initialization
+
+  CALL MPI_INIT_THREAD(3, provided, ierr)
+    if(provided .NE. 3) then
+      print*, "provided thread level = ", provided
+      call MPI_Abort()
+    endif 
+
+  
+
+  CALL init_wait
+
+  CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
+  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
+  if(rank < size-2) then
+
+  !$omp parallel default(private)
+
+!!! XIOS Initialization (get the local communicator)
+
+  CALL xios_initialize(id,return_comm=comm)
+
+  CALL MPI_COMM_RANK(comm,rank,ierr)
+  CALL MPI_COMM_SIZE(comm,size_loc,ierr)
+
+  size_loc = size_loc*omp_get_num_threads()
+  rank = rank*omp_get_num_threads() + omp_get_thread_num()
+
+
+!###########################################################################
+! Contexte ATM
+!###########################################################################
+
+!!! Initialisation des coordonnes globales et locales pour la grille rgulire
+
+  DO j=1,nj_glo
+    DO i=1,ni_glo
+      lon_glo(i,j)=(i-1)+(j-1)*ni_glo
+      lat_glo(i,j)=1000+(i-1)+(j-1)*ni_glo
+      DO l=1,llm
+        field_A_glo(i,j,l)=(i-1)+(j-1)*ni_glo+10000*l
+      ENDDO
+    ENDDO
+  ENDDO
+  ni=ni_glo ; ibegin=0
+
+  jbegin=0
+  DO n=0,size_loc-1
+    nj=nj_glo/size_loc
+    IF (n<MOD(nj_glo,size_loc)) nj=nj+1
+    IF (n==rank) exit
+    jbegin=jbegin+nj
+  ENDDO
+
+  iend=ibegin+ni-1 ; jend=jbegin+nj-1
+
+  ALLOCATE(lon(ni,nj),lat(ni,nj),field_A_atm(0:ni+1,-1:nj+2,llm),lonvalue(ni,nj))
+  lon(:,:)=lon_glo(ibegin+1:iend+1,jbegin+1:jend+1)
+  lat(:,:)=lat_glo(ibegin+1:iend+1,jbegin+1:jend+1)
+  field_A_atm(1:ni,1:nj,:)=field_A_glo(ibegin+1:iend+1,jbegin+1:jend+1,:)
+
+
+!!! Context ATMOSPHERE
+
+  CALL xios_context_initialize("atmosphere",comm)
+
+  CALL xios_get_handle("atmosphere",ctx_hdl)
+  CALL xios_set_current_context(ctx_hdl)
+
+  CALL xios_define_calendar(type="Gregorian", &
+                            start_date=xios_date(2000, 01, 01, 00, 00, 00), &
+                            time_origin=xios_date(1999, 01, 01, 15, 00, 00))
+
+  CALL xios_set_axis_attr("axis_atm",n_glo=llm ,value=lval) ;
+
+  CALL xios_set_domain_attr("domain_atm",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
+  CALL xios_set_domain_attr("domain_atm",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
+  CALL xios_set_domain_attr("domain_atm",lonvalue_2D=lon,latvalue_2D=lat)
+
+  CALL xios_set_domain_attr("domain_atm_zoom",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj)
+  CALL xios_set_domain_attr("domain_atm_zoom",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
+  CALL xios_set_domain_attr("domain_atm_zoom",lonvalue_2D=lon,latvalue_2D=lat)
+
+
+!!! Activation du groupe field_definition
+
+  CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
+
+!!! Cration d un nouveau champ
+
+  CALL xios_get_handle("field_definition",fieldgroup_hdl)
+  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B_atm")
+
+!!! Heritage des attributs d un autre champ
+
+  CALL xios_set_attr(field_hdl,field_ref="field_A_atm_zoom",name="field_B_atm")
+
+!!! Affectation de ce nouveau champ au fichier avec un nouveau nom
+
+  CALL xios_get_handle("output_atmosphere",file_hdl)
+  CALL xios_add_child(file_hdl,field_hdl)
+  CALL xios_set_attr(field_hdl,field_ref="field_B_atm",name="field_C_atm")
+
+!!! Definition du timestep
+
+  dtime%second=3600
+  CALL xios_set_timestep(timestep=dtime)
+
+!!! Recupration des valeurs des longitudes et de taille des domaines locaux (pour test de fonctionnalit)
+
+  ni=0 ; lonvalue(:,:)=0
+  CALL xios_get_domain_attr("domain_atm",ni=ni,lonvalue_2D=lonvalue)
+
+  !PRINT *,"ni",ni
+  !PRINT *,"lonvalue",lonvalue;
+
+!!! Fin de la definition du contexte
+
+  CALL xios_close_context_definition()
+
+   print *, "xios_close_context_definition(atmosphere)"
+
+!!! Test des valeurs des champs/fichiers
+
+  !!! Attribut defini ?
+
+  CALL xios_is_defined_field_attr("field_A_atm",enabled=ok)
+  PRINT *,"field_A_atm : attribute enabled is defined ? ",ok
+
+  !!! Recuperer la valeur d un attribut
+
+  CALL xios_get_field_attr("field_A_atm",name=crname)
+  PRINT *,"field_A_atm : attribute name is : ",TRIM(crname)
+
+  !!! Champ actif (besoin de fournir la valeur) ?
+
+    PRINT*,"field field_A_atm is active ? ",xios_field_is_active("field_A_atm")
+
+  !!! Champ defini ?
+
+    PRINT*,"field field_A_atm is valid ?",xios_is_valid_field("field_A_atm")
+
+
+!###########################################################################
+! Contexte SRF
+!###########################################################################
+
+!!! Initialisation des coordonnes globales et locales pour la grille indexee (1 point sur 2)
+
+    nb_pt=ni*nj/2
+    ALLOCATE(kindex(nb_pt),field_A_srf(nb_pt,llm))
+    DO i=1,nb_pt
+      kindex(i)=2*i-1
+    ENDDO
+    field_A_srf(1:nb_pt,:)=RESHAPE(field_A_glo(ibegin+1:iend+1:2,jbegin+1:jend+1,:),(/ nb_pt,llm /))
+
+  CALL xios_context_initialize("surface",comm)
+
+
+  CALL xios_get_handle("surface",ctx_hdl)
+  CALL xios_set_current_context(ctx_hdl)
+
+  CALL xios_define_calendar(type="Gregorian", &
+                            start_date=xios_date(2000, 01, 01, 00, 00, 00), &
+                            time_origin=xios_date(1999, 01, 01, 15, 00, 00))
+
+  CALL xios_set_axis_attr("axis_srf",n_glo=llm ,value=lval)
+  CALL xios_set_domain_attr("domain_srf",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj, type='curvilinear')
+  CALL xios_set_domain_attr("domain_srf",data_dim=1, data_ibegin=0, data_ni=nb_pt)
+  CALL xios_set_domain_attr("domain_srf",data_i_index=kindex)
+  CALL xios_set_domain_attr("domain_srf",lonvalue_2D=lon,latvalue_2D=lat)
+
+!!! Cration d un nouveau champ
+
+  CALL xios_get_handle("field_definition",fieldgroup_hdl)
+  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B_srf")
+
+!!! Heritage des attributs d un autre champ
+
+  CALL xios_set_attr(field_hdl,field_ref="field_A_srf",name="field_B_srf")
+
+!!! Affectation de ce nouveau champ au fichier avec un nouveau nom
+
+  CALL xios_get_handle("output_surface",file_hdl)
+  CALL xios_add_child(file_hdl,field_hdl)
+  CALL xios_set_attr(field_hdl,field_ref="field_B_srf",name="field_C_srf")
+
+!!! Definition du timestep
+
+  dtime%second=1800
+  CALL xios_set_timestep(timestep=dtime)
+
+!!! Recupration des valeurs des longitudes et de taille des domaines locaux (pour test de fonctionnalit)
+
+  ni=0 ; lonvalue(:,:)=0
+  CALL xios_get_domain_attr("domain_srf",ni=ni,lonvalue_2D=lonvalue)
+
+  !PRINT *,"ni",ni
+  !PRINT *,"lonvalue",lonvalue ;
+
+!!! Fin de la definition du contexte SRF
+
+  CALL xios_get_handle("surface",ctx_hdl)
+  CALL xios_set_current_context(ctx_hdl)
+
+  CALL xios_close_context_definition()
+
+  print *, "xios_close_context_definition(surface)", rank, size_loc 
+
+
+
+!####################################################################################
+!!! Boucle temporelle
+!####################################################################################
+
+    DO ts=1,24*2
+    !DO ts=1,24
+
+      CALL xios_get_handle("atmosphere",ctx_hdl)
+      CALL xios_set_current_context(ctx_hdl)
+
+!!! Mise a jour du pas de temps
+
+      CALL xios_update_calendar(ts)
+
+!!! On donne la valeur du champ atm
+
+      CALL xios_send_field("field_A_atm",field_A_atm)
+
+!!! On change de contexte
+
+      CALL xios_get_handle("surface",ctx_hdl)
+      CALL xios_set_current_context(ctx_hdl)
+
+!!! Mise a jour du pas de temps
+
+      CALL xios_update_calendar(ts)
+
+!!! On donne la valeur du champ srf
+
+      CALL xios_send_field("field_A_srf",field_A_srf)
+
+      CALL wait_us(5000) ;
+
+
+    ENDDO
+
+     print *, "end temporal loop"
+
+!####################################################################################
+!!! Finalisation
+!####################################################################################
+
+!!! Fin des contextes
+
+     CALL xios_get_handle("surface",ctx_hdl) 
+
+     CALL xios_set_current_context(ctx_hdl)
+
+     CALL xios_context_finalize()
+
+     print *, "xios_context_finalize(surface)" 
+
+     CALL xios_get_handle("atmosphere",ctx_hdl)
+
+     CALL xios_set_current_context(ctx_hdl)
+
+     CALL xios_context_finalize()
+
+     print *, "xios_context_finalize(atmosphere)"
+
+    
+
+!!! Fin de XIOS
+
+    
+
+    CALL xios_finalize()
+
+    DEALLOCATE(lon, lat, field_A_atm, lonvalue)
+    DEALLOCATE(kindex, field_A_srf)
+
+    print *, "Client : xios_finalize "
+
+    !$omp barrier
+
+    !$omp master 
+    CALL MPI_COMM_FREE(comm, ierr)
+    !$omp end master
+
+    !$omp barrier
+
+   
+
+  !$omp end parallel
+
+  else
+
+    CALL xios_init_server
+    print *, "Server : xios_finalize "
+  
+    endif
+
+
+    CALL MPI_FINALIZE(ierr)
+
+  END PROGRAM test_complete_omp
+
+
+
+
+
+
Index: /XIOS/dev/branch_yushan_merged/src/test/test_omp.f90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/test/test_omp.f90	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/src/test/test_omp.f90	(revision 1134)
@@ -0,0 +1,194 @@
+PROGRAM test_omp
+
+  USE xios
+  USE mod_wait
+  use omp_lib
+  IMPLICIT NONE
+  INCLUDE "mpif.h"
+  INTEGER :: rank
+  INTEGER :: size
+  INTEGER :: ierr
+
+  CHARACTER(len=*),PARAMETER :: id="client"
+  INTEGER :: comm
+  TYPE(xios_duration) :: dtime
+  CHARACTER(len=20) :: dtime_str
+  TYPE(xios_date) :: date
+  CHARACTER(len=20) :: date_str
+  CHARACTER(len=15) :: calendar_type
+  TYPE(xios_context) :: ctx_hdl
+  INTEGER,PARAMETER :: ni_glo=100
+  INTEGER,PARAMETER :: nj_glo=100
+  INTEGER,PARAMETER :: llm=5
+  DOUBLE PRECISION  :: lval(llm)=1
+  TYPE(xios_field) :: field_hdl
+  TYPE(xios_fieldgroup) :: fieldgroup_hdl
+  TYPE(xios_file) :: file_hdl
+  LOGICAL :: ok
+
+  DOUBLE PRECISION,DIMENSION(ni_glo,nj_glo) :: lon_glo,lat_glo
+  DOUBLE PRECISION :: field_A_glo(ni_glo,nj_glo,llm)
+  DOUBLE PRECISION,ALLOCATABLE :: lon(:,:),lat(:,:),field_A(:,:,:), lonvalue(:,:) ;
+  INTEGER :: ni,ibegin,iend,nj,jbegin,jend
+  INTEGER :: i,j,l,ts,n, provided
+
+!!! MPI Initialization   
+
+    CALL MPI_INIT_THREAD(3, provided, ierr)
+    if(provided .NE. 3) then
+      print*, "provided thread level = ", provided
+      call MPI_Abort()
+    endif
+
+    CALL init_wait
+
+    CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
+    CALL MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
+    if(rank < size-2) then
+
+    !$omp parallel default(private)
+  
+    CALL xios_initialize(id,return_comm=comm)
+  
+    CALL MPI_COMM_RANK(comm,rank,ierr)
+    CALL MPI_COMM_SIZE(comm,size,ierr)
+
+    size = size*omp_get_num_threads()
+    rank = rank*omp_get_num_threads() + omp_get_thread_num()
+
+    DO j=1,nj_glo
+      DO i=1,ni_glo
+        lon_glo(i,j)=(i-1)+(j-1)*ni_glo
+        lat_glo(i,j)=1000+(i-1)+(j-1)*ni_glo
+        DO l=1,llm
+          field_A_glo(i,j,l)=(i-1)+(j-1)*ni_glo+10000*l
+        ENDDO
+      ENDDO
+    ENDDO
+    ni=ni_glo ; ibegin=0
+
+    jbegin=0
+    DO n=0,size-1
+      nj=nj_glo/size
+      IF (n<MOD(nj_glo,size)) nj=nj+1
+      IF (n==rank) exit
+      jbegin=jbegin+nj
+    ENDDO
+
+    iend=ibegin+ni-1 ; jend=jbegin+nj-1
+
+    ALLOCATE(lon(ni,nj),lat(ni,nj),field_A(0:ni+1,-1:nj+2,llm),lonvalue(ni,nj))
+    lon(:,:)=lon_glo(ibegin+1:iend+1,jbegin+1:jend+1)
+    lat(:,:)=lat_glo(ibegin+1:iend+1,jbegin+1:jend+1)
+    field_A(1:ni,1:nj,:)=field_A_glo(ibegin+1:iend+1,jbegin+1:jend+1,:)
+
+    !print*, "xios init OK", rank, size
+
+    CALL xios_context_initialize("test",comm)
+
+    !print*, "xios_context_initialize OK", rank, size
+
+    CALL xios_get_handle("test",ctx_hdl)
+    CALL xios_set_current_context(ctx_hdl)
+  
+  
+    CALL xios_get_calendar_type(calendar_type)
+    !print*, "xios_get_calendar_type OK", rank, size
+
+    CALL xios_set_axis_attr("axis_A",n_glo=llm ,value=lval) ;
+    CALL xios_set_domain_attr("domain_A",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj,type='curvilinear')
+    CALL xios_set_domain_attr("domain_A",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
+    CALL xios_set_domain_attr("domain_A",lonvalue_2D=lon,latvalue_2D=lat)
+    CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
+    !print*, "test block OK", rank, size
+
+    CALL xios_get_handle("field_definition",fieldgroup_hdl)
+    CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
+    CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
+
+    CALL xios_get_handle("output",file_hdl)
+    CALL xios_add_child(file_hdl,field_hdl)
+    CALL xios_set_attr(field_hdl,field_ref="field_A_zoom",name="field_C")
+
+    dtime%second = 3600
+    CALL xios_set_timestep(dtime)
+    !print*, "xios_set_timestep OK", rank, size    
+
+   ! The calendar is created as soon as the calendar type is defined. This way
+   ! calendar operations can be used before the context definition is closed
+   CALL xios_get_time_origin(date)
+   !PRINT *, "--> year length = ", xios_get_year_length_in_seconds(date%year)
+   !PRINT *, "--> day length = ", xios_get_day_length_in_seconds()
+   CALL xios_date_convert_to_string(date, date_str)
+   !PRINT *, "time_origin = ", date_str
+   !PRINT *, "xios_date_get_second_of_year(time_origin) = ", xios_date_get_second_of_year(date)
+   !PRINT *, "xios_date_get_day_of_year(time_origin) = ", xios_date_get_day_of_year(date)
+   !PRINT *, "xios_date_get_fraction_of_year(time_origin) = ", xios_date_get_fraction_of_year(date)
+   !PRINT *, "xios_date_get_second_of_day(time_origin) = ", xios_date_get_second_of_day(date)
+   !PRINT *, "xios_date_get_fraction_of_day(time_origin) = ", xios_date_get_fraction_of_day(date)
+   dtime%timestep = 1
+   dtime = 0.5 * dtime
+   CALL xios_duration_convert_to_string(dtime, dtime_str)
+   !PRINT *, "duration = ", dtime_str
+   date = date + 3 * (dtime + dtime)
+   CALL xios_date_convert_to_string(date, date_str)
+   !PRINT *, "date = time_origin + 3 * (duration + duration) = ", date_str
+   !PRINT *, "xios_date_convert_to_seconds(date) = ", xios_date_convert_to_seconds(date)
+   !PRINT *, "xios_date_convert_to_seconds(date - 2.5h) = ", xios_date_convert_to_seconds(date - 2.5 * xios_hour)
+
+   ni=0 ; lonvalue(:,:)=0;
+   CALL xios_get_domain_attr("domain_A",ni=ni,lonvalue_2D=lonvalue)
+   !print *,"ni",ni
+   !print *,"lonvalue",lonvalue;
+
+   CALL xios_is_defined_field_attr("field_A",enabled=ok)
+   !PRINT *,"field_A : attribute enabled is defined ? ",ok 
+
+   CALL xios_close_context_definition()
+   !print*, "xios_close_context_definition OK"  
+
+   PRINT*,"field field_A is active ? ",xios_field_is_active("field_A")
+
+   DO ts=1,6
+    CALL xios_update_calendar(ts)
+    CALL xios_send_field("field_A",field_A)
+    CALL wait_us(5000)
+   ENDDO
+
+    CALL xios_context_finalize()
+    !print*, "xios_context_finalize OK", rank, size
+
+    CALL xios_finalize()
+    print*, "xios finalize OK", rank, size
+
+    DEALLOCATE(lon, lat, field_A, lonvalue)
+    !$omp master 
+    !call MPI_Barrier(comm)
+    CALL MPI_COMM_FREE(comm, ierr)
+    !$omp end master
+
+     !$omp barrier
+
+     !print*, "MPI_COMM_FREE OK", rank, size
+
+
+
+  !$omp end parallel
+
+
+    else
+
+    CALL xios_init_server
+    print *, "Server : xios_finalize "
+  
+    endif
+    
+
+  CALL MPI_FINALIZE(ierr)
+
+END PROGRAM test_omp
+
+
+
+
+
Index: /XIOS/dev/branch_yushan_merged/src/timer.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/timer.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/timer.cpp	(revision 1134)
@@ -8,4 +8,5 @@
 {
   std::map<std::string,CTimer> CTimer::allTimer;
+  std::map<std::string,CTimer> *CTimer::allTimer_ptr = 0;
   
   CTimer::CTimer(const std::string& name_) : name(name_) 
@@ -52,7 +53,15 @@
   CTimer& CTimer::get(const std::string name)
   {
-    std::map<std::string,CTimer>::iterator it = allTimer.find(name);
-    if (it == allTimer.end())
-      it = allTimer.insert(std::make_pair(name, CTimer(name))).first;
+    // bkp
+    // std::map<std::string,CTimer>::iterator it = allTimer.find(name);
+    // if (it == allTimer.end())
+    //   it = allTimer.insert(std::make_pair(name, CTimer(name))).first;
+    // return it->second;
+
+    if(allTimer_ptr == NULL) allTimer_ptr = new std::map<std::string,CTimer>;
+
+    std::map<std::string,CTimer>::iterator it = (*allTimer_ptr).find(name);
+    if (it == (*allTimer_ptr).end())
+      it = (*allTimer_ptr).insert(std::make_pair(name, CTimer(name))).first;
     return it->second;
   }
Index: /XIOS/dev/branch_yushan_merged/src/timer.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/timer.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/timer.hpp	(revision 1134)
@@ -21,4 +21,8 @@
       double getCumulatedTime(void);
       static std::map<std::string,CTimer> allTimer;
+
+      static std::map<std::string,CTimer> *allTimer_ptr;
+      #pragma omp threadprivate(allTimer_ptr)
+      
       static double getTime(void);
       static CTimer& get(std::string name);
Index: /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.cpp	(revision 1134)
@@ -9,5 +9,7 @@
 
 CReductionAlgorithm::CallBackMap* CReductionAlgorithm::reductionCreationCallBacks_ = 0;
-std::map<StdString,EReductionType> CReductionAlgorithm::ReductionOperations = std::map<StdString,EReductionType>();
+//std::map<StdString,EReductionType> CReductionAlgorithm::ReductionOperations = std::map<StdString,EReductionType>();
+std::map<StdString,EReductionType> *CReductionAlgorithm::ReductionOperations_ptr = 0; 
+
 bool CReductionAlgorithm::initReductionOperation(std::map<StdString,EReductionType>& m)
 {
@@ -29,9 +31,34 @@
 }
 
-bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation(CReductionAlgorithm::ReductionOperations);
+
+bool CReductionAlgorithm::initReductionOperation()
+{
+  if(CReductionAlgorithm::ReductionOperations_ptr == NULL) CReductionAlgorithm::ReductionOperations_ptr = new std::map<StdString,EReductionType>();
+  // So so stupid way to intialize operation but it works ...
+  (*CReductionAlgorithm::ReductionOperations_ptr)["sum"] = TRANS_REDUCE_SUM;
+  CSumReductionAlgorithm::registerTrans();
+
+  (*CReductionAlgorithm::ReductionOperations_ptr)["min"] = TRANS_REDUCE_MIN;
+  CMinReductionAlgorithm::registerTrans();
+
+  (*CReductionAlgorithm::ReductionOperations_ptr)["max"] = TRANS_REDUCE_MAX;
+  CMaxReductionAlgorithm::registerTrans();
+
+  (*CReductionAlgorithm::ReductionOperations_ptr)["extract"] = TRANS_REDUCE_EXTRACT;
+  CExtractReductionAlgorithm::registerTrans();
+
+  (*CReductionAlgorithm::ReductionOperations_ptr)["average"] = TRANS_REDUCE_AVERAGE;
+  CAverageReductionAlgorithm::registerTrans();
+}
+
+//bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation(CReductionAlgorithm::ReductionOperations);
+bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation();
 
 CReductionAlgorithm* CReductionAlgorithm::createOperation(EReductionType reduceType)
 {
   int reduceTypeInt = reduceType;
+  //if (0 == reductionCreationCallBacks_)
+  //  reductionCreationCallBacks_ = new CallBackMap();
+
   CallBackMap::const_iterator it = (*reductionCreationCallBacks_).find(reduceType);
   if ((*reductionCreationCallBacks_).end() == it)
Index: /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/Functions/reduction.hpp	(revision 1134)
@@ -23,5 +23,7 @@
 {
 public:
-  static std::map<StdString,EReductionType> ReductionOperations;
+  //static std::map<StdString,EReductionType> ReductionOperations;
+  static std::map<StdString,EReductionType> *ReductionOperations_ptr;
+  #pragma omp threadprivate(ReductionOperations_ptr)
 
 public:
@@ -60,4 +62,5 @@
   typedef std::map<EReductionType, CreateOperationCallBack> CallBackMap;
   static CallBackMap* reductionCreationCallBacks_;
+  #pragma omp threadprivate(reductionCreationCallBacks_)
 
   static bool registerOperation(EReductionType reduceType, CreateOperationCallBack createFn);
@@ -66,5 +69,7 @@
 protected:
   static bool initReductionOperation(std::map<StdString,EReductionType>& m);
+  static bool initReductionOperation();
   static bool _dummyInit;
+  #pragma omp threadprivate(_dummyInit)
 };
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1134)
@@ -62,5 +62,5 @@
 
   pos_ = algo->position;
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.cpp	(revision 1134)
@@ -173,6 +173,6 @@
 
   // Sending global index of grid source to corresponding process as well as the corresponding mask
-  std::vector<MPI_Request> requests;
-  std::vector<MPI_Status> status;
+  std::vector<ep_lib::MPI_Request> requests;
+  std::vector<ep_lib::MPI_Status> status;
   boost::unordered_map<int, unsigned long* > recvGlobalIndexSrc;
   boost::unordered_map<int, double* > sendValueToDest;
@@ -184,5 +184,5 @@
     sendValueToDest[recvRank] = new double [recvSize];
 
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Irecv(recvGlobalIndexSrc[recvRank], recvSize, MPI_UNSIGNED_LONG, recvRank, 46, client->intraComm, &requests.back());
   }
@@ -206,5 +206,5 @@
 
     // Send global index source and mask
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendGlobalIndexSrc[sendRank], sendSize, MPI_UNSIGNED_LONG, sendRank, 46, client->intraComm, &requests.back());
   }
@@ -213,7 +213,6 @@
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
 
-
-  std::vector<MPI_Request>().swap(requests);
-  std::vector<MPI_Status>().swap(status);
+  std::vector<ep_lib::MPI_Request>().swap(requests);
+  std::vector<ep_lib::MPI_Status>().swap(status);
 
   // Okie, on destination side, we will wait for information of masked index of source
@@ -223,5 +222,5 @@
     int recvSize = itSend->second;
 
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Irecv(recvValueFromSrc[recvRank], recvSize, MPI_DOUBLE, recvRank, 48, client->intraComm, &requests.back());
   }
@@ -241,10 +240,9 @@
     }
     // Okie, now inform the destination which source index are masked
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendValueToDest[recvRank], recvSize, MPI_DOUBLE, recvRank, 48, client->intraComm, &requests.back());
   }
   status.resize(requests.size());
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
-
 
   size_t nGloAxisDest = axisDest_->n_glo.getValue() - 1;
Index: /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_inverse.hpp	(revision 1134)
@@ -12,5 +12,8 @@
 #include "axis_algorithm_transformation.hpp"
 #include "transformation.hpp"
-
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+   
 namespace xios {
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1134)
@@ -70,5 +70,5 @@
 
   dir_ = (CReduceDomainToAxis::direction_attr::iDir == algo->direction)  ? iDir : jDir;
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.cpp	(revision 1134)
@@ -405,10 +405,10 @@
   CContextClient* client=context->client;
 
-  MPI_Comm poleComme(MPI_COMM_NULL);
-  MPI_Comm_split(client->intraComm, interMapValuePole.empty() ? MPI_UNDEFINED : 1, 0, &poleComme);
+  ep_lib::MPI_Comm poleComme(MPI_COMM_NULL);
+  ep_lib::MPI_Comm_split(client->intraComm, interMapValuePole.empty() ? MPI_UNDEFINED : 1, 0, &poleComme);
   if (MPI_COMM_NULL != poleComme)
   {
     int nbClientPole;
-    MPI_Comm_size(poleComme, &nbClientPole);
+    ep_lib::MPI_Comm_size(poleComme, &nbClientPole);
 
     std::map<int,std::vector<std::pair<int,double> > >::iterator itePole = interMapValuePole.end(), itPole,
@@ -573,5 +573,5 @@
   double* sendWeightBuff = new double [sendBuffSize];
 
-  std::vector<MPI_Request> sendRequest;
+  std::vector<ep_lib::MPI_Request> sendRequest;
 
   int sendOffSet = 0, l = 0;
@@ -594,5 +594,5 @@
     }
 
-    sendRequest.push_back(MPI_Request());
+    sendRequest.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendIndexDestBuff + sendOffSet,
              k,
@@ -602,5 +602,5 @@
              client->intraComm,
              &sendRequest.back());
-    sendRequest.push_back(MPI_Request());
+    sendRequest.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendIndexSrcBuff + sendOffSet,
              k,
@@ -610,5 +610,5 @@
              client->intraComm,
              &sendRequest.back());
-    sendRequest.push_back(MPI_Request());
+    sendRequest.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendWeightBuff + sendOffSet,
              k,
@@ -629,5 +629,5 @@
   while (receivedSize < recvBuffSize)
   {
-    MPI_Status recvStatus;
+    ep_lib::MPI_Status recvStatus;
     MPI_Recv((recvIndexDestBuff + receivedSize),
              recvBuffSize,
@@ -640,6 +640,9 @@
     int countBuff = 0;
     MPI_Get_count(&recvStatus, MPI_INT, &countBuff);
+    #ifdef _usingMPI
     clientSrcRank = recvStatus.MPI_SOURCE;
-
+    #elif _usingEP
+    clientSrcRank = recvStatus.ep_src;
+    #endif
     MPI_Recv((recvIndexSrcBuff + receivedSize),
              recvBuffSize,
@@ -666,6 +669,7 @@
   }
 
-  std::vector<MPI_Status> requestStatus(sendRequest.size());
-  MPI_Waitall(sendRequest.size(), &sendRequest[0], MPI_STATUS_IGNORE);
+  std::vector<ep_lib::MPI_Status> requestStatus(sendRequest.size());
+  ep_lib::MPI_Status stat_ignore;
+  MPI_Waitall(sendRequest.size(), &sendRequest[0], &stat_ignore);
 
   delete [] sendIndexDestBuff;
@@ -758,5 +762,5 @@
 
   MPI_Allreduce(&localNbWeight, &globalNbWeight, 1, MPI_LONG, MPI_SUM, client->intraComm);
-  MPI_Scan(&localNbWeight, &startIndex, 1, MPI_LONG, MPI_SUM, client->intraComm);
+  ep_lib::MPI_Scan(&localNbWeight, &startIndex, 1, MPI_LONG, MPI_SUM, client->intraComm);
   
   if (0 == globalNbWeight)
@@ -771,6 +775,6 @@
   std::vector<StdSize> start(1, startIndex - localNbWeight);
   std::vector<StdSize> count(1, localNbWeight);
-  
-  WriteNetCdf netCdfWriter(filename, client->intraComm);  
+
+  WriteNetCdf netCdfWriter(filename, static_cast<MPI_Comm>(client->intraComm.mpi_comm));
 
   // Define some dimensions
Index: /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/domain_algorithm_interpolate.hpp	(revision 1134)
@@ -13,4 +13,7 @@
 #include "transformation.hpp"
 #include "nc4_data_output.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace xios {
